""" Module and plugin lister. """

from glob import glob
from os import makedirs
from os.path import dirname, basename, isfile, exists
from aya import logger, working_dir


def __internals():
    paths = glob(f"{dirname(__file__)}/*.py")
    return [
        basename(file)[:-3]
        for file in paths
        if isfile(file) and file.endswith(".py") and not file.endswith("__init__.py")
    ]


def __plugins():
    if not exists(f"{working_dir}/plugins"):
        makedirs(f"{working_dir}/plugins")
    paths = glob(f"{working_dir}/plugins/*.py")
    return [
        basename(file)[:-3]
        for file in paths
        if isfile(file) and file.endswith(".py")
    ]


internal_list = sorted(__internals())
plugin_list = sorted(__plugins())
internal_string = None
plugin_string = None

string = ""
for module in internal_list:
    string += f"{module}, "
internal_string = string[:-2]
string = ""
for module in plugin_list:
    string += f"{module}, "
plugin_string = string[:-2] if len(plugin_list) != 0 else None
string = None

logger.info(f"Initialized internal modules: {internal_string}")
if plugin_string is not None:
    logger.info(f"Initialized external plugins: {plugin_string}")
