""" Miscellaneous utilities. """

from random import choice, randrange
from discord.ext.commands import Cog, command, cooldown, BucketType
from aya.utils import localization


class Miscellaneous(Cog):
    """ misc_desc """

    @command(aliases=["flip", "coin"])
    async def coinflip(self, context):
        """ misc_help_coinflip """
        results = [localization.get_string("misc_flip_heads", context),
                   localization.get_string("misc_flip_tails", context)]
        await context.send(choice(results))

    @command(aliases=['slots', 'roll'])
    @cooldown(rate=3, per=5, type=BucketType.user)
    async def slot(self, context):
        """ misc_help_slot """
        emotes = ["<:CirnoHappy:638229632604438548>", "<:SakuyaMug:670139649699872770>",
                  "<:MarisaHappy:678333437760765982>", "<:Dosmuggy:632037121938423828>",
                  "<:SurprisedBirb:674724337609211915>", "<:FlandreLaugh:460351444621721601>",
                  "<:YuyukoHungry:678333380542201879>", "<:SagumeUhh:678338161541120095>",
                  "<:SupportiveRumia:678341757389373500>", "<:KeikiPout:678333519906340877>",
                  "<:HeyaNazu:678333545961226310>", "<:SumiUhh:678341740301647882>",
                  "<:Hina:460232504578670602>", "<:ClownpieceCheer:670374486406856755>",
                  "<:TewiWink:460589669411717121>", "<:SmugRaiko:460659835776794624>"]
        first = randrange(0, 15, 1)
        second = randrange(0, 15, 1)
        third = randrange(0, 15, 1)

        output = f"**[ {emotes[first]} | {emotes[second]} | {emotes[third]} ]**\n"

        if first == second == third:
            await context.send(f"{output} {localization.get_string('misc_slot_match_all', context)}")
        elif (first == second) or (second == third) or (first == third):
            await context.send(f"{output} {localization.get_string('misc_slot_match_two', context)}")
        else:
            await context.send(f"{output} {localization.get_string('misc_slot_match_nil', context)}")


def setup(client):
    client.add_cog(Miscellaneous())
