""" Touhou specific utilities. """

from discord import Embed
from discord.ext.commands import Cog, BucketType, command, group, cooldown
from aya.utils import touhou, localization


class Touhou(Cog):
    """ th_desc """

    @command(aliases=["th", "touhou"])
    @cooldown(rate=3, per=5, type=BucketType.user)
    async def touhou_image(self, context, character_argument: str = None):
        """ th_help_image """
        if character_argument is not None:
            character_sanitized = character_argument[0].upper() + character_argument.lower()[1:]
        else:
            character_sanitized = None
        if character_sanitized in touhou.all_characters:
            return await context.send(
                embed=await touhou.retrieve_image(touhou.all_characters[character_sanitized][0],
                                                  touhou.all_characters[character_sanitized][1],
                                                  character_sanitized))
        else:
            content = Embed(title=localization.get_string("th_image_help_title", context),
                            description=localization.get_string("th_image_help_desc", context))
            inline = True
            for character in touhou.all_characters:
                content.add_field(name=character,
                                  value=f" "
                                        f"{touhou.all_characters[character][0].replace('_', ' ')}.",
                                  inline=True)
                if inline:
                    inline = False
                else:
                    inline = True
            return await context.send(embed=content)


def setup(nitori):
    nitori.add_cog(Touhou())
