const timezone = jstz.determine();
document.getElementById("TimezoneFetcher").value = timezone.name();
let activePage = 0;
showPage(activePage);

function showPage(n) {
    let x = document.getElementsByClassName("page");
    x[n].style.display = "block";
    if (n === 0) {
        document.getElementById("prevBtn").style.display = "none";
    } else {
        document.getElementById("prevBtn").style.display = "inline";
    }
    if (n === (x.length - 1)) {
        document.getElementById("nextBtn").innerHTML = "Submit";
    } else {
        document.getElementById("nextBtn").innerHTML = "Next";
    }
    updatePageMarker(n)
}

function switchPage(n) {
    let x = document.getElementsByClassName("page");
    if (n === 1 && !validateForm()) return false;
    x[activePage].style.display = "none";
    activePage = activePage + n;
    if (activePage >= x.length) {
        document.getElementById("regForm").submit();
        return false;
    }
    showPage(activePage);
}

function validateForm() {
    let elements, text_inputs, selections, i, j, textareas;
    elements = document.getElementsByClassName("page");
    text_inputs = elements[activePage].getElementsByTagName("input");
    selections = elements[activePage].getElementsByTagName("select");
    textareas = elements[activePage].getElementsByTagName("textarea")
    for (i = 0; i < text_inputs.length; i++) {
        if (text_inputs[i].value === "") {
            text_inputs[i].className += " invalid";
            return false;
        }
    }
    for (i = 0; i < selections.length; i++) {
        if (selections[i].value === "") {
            selections[i].className += " invalid";
            return false;
        }
    }
    for (i = 0; i < textareas.length; i++) {
        if (textareas[i].value.length >= 256) {
            textareas[i].className += " invalid";
            return false;
        }
        if (!/^[\x00-\x7F]*$/.test(textareas[i].value)) {
            textareas[i].className += " invalid";
            return false;
        }
    }
    document.getElementsByClassName("page-marker")[activePage].className += " completed";
    return true;
}

function updatePageMarker(n) {
    let i, markers = document.getElementsByClassName("page-marker");
    for (i = 0; i < markers.length; i++) {
        markers[i].className = markers[i].className.replace(" active", "");
    }
    markers[n].className += " active";
}
