""" Aya library. """

from os.path import exists
from shutil import copyfile
from yaml import load, FullLoader
from discord.ext.commands import Converter, MemberConverter, BadArgument
from asyncio.subprocess import PIPE
from asyncio import create_subprocess_shell


first_run = False
if not exists("config.yml"):
    copyfile(f"{__path__[0]}/../assets/config-sample.yml", "config.yml")
    first_run = True

config = load(open("config.yml"), Loader=FullLoader)
system_administrators = config.get("system_administrators", None)
operators = config.get("operators", None)


class MemberID(Converter):
    async def convert(self, context, argument):
        try:
            member = await MemberConverter().convert(context, argument)
        except BadArgument:
            try:
                return int(argument,
                           base=10)
            except ValueError:
                raise BadArgument(f"{argument} is invalid.") from None
        else:
            return member.id


async def execute(command, pass_error=True):
    """ Executes command and returns output, with the option of enabling stderr. """
    executor = await create_subprocess_shell(
        command,
        stdout=PIPE,
        stderr=PIPE
    )
    stdout, stderr = await executor.communicate()
    if pass_error:
        result = str(stdout.decode().strip()) \
                 + str(stderr.decode().strip())
    else:
        result = str(stdout.decode().strip())
    return result
