""" Leveling utilities. """

from aya import redis


def calculate_level(exp):
    interval = 100
    level = 0
    while interval <= exp:
        exp -= interval
        interval = int((interval / 5) * 110 / 100) * 5
        level += 1
    return level


def calculate_exp(level):
    interval = 100
    exp = 0
    runtime = 0
    while runtime < level:
        exp += interval
        interval = int((interval / 5) * 110 / 100) * 5
        runtime += 1
    return exp


def get_exp(uid, gid):
    exp = redis.hget(f"exp.{gid}", f"{uid}")
    if exp:
        return int(exp.decode("utf-8"))
    return False


def get_exps(gid):
    origin = redis.hgetall(f"exp.{gid}")
    result = {}
    for encoded_userid in origin:
        uid = int(encoded_userid.decode("utf-8"))
        result.update({uid: get_exp(uid, gid)})
    return result


def set_exp(uid, gid, exp: int):
    redis.hset(f"exp.{gid}", f"{uid}", str(exp))


def del_exp(uid, gid):
    redis.hdel(f"exp.{gid}", f"{uid}")
