""" Localization related utilities. """

from yaml import load, FullLoader
from aya import module_dir, logger
from aya.utils import customize, config

locales = {"en_US": load(open(f"{module_dir}/assets/languages/en_US.yml"), Loader=FullLoader),
           "nl_NL": load(open(f"{module_dir}/assets/languages/nl_NL.yml"), Loader=FullLoader),
           "fr_FR": load(open(f"{module_dir}/assets/languages/fr_FR.yml"), Loader=FullLoader)}


def get_string(string_name, context):
    """ Fetches a localized string. """
    try:
        gid = context.guild.id
    except AttributeError:
        gid = None
    try:
        if not gid:
            return locales[config["default_language"]][string_name]
        else:
            return locales[customize.get_language(gid)][string_name]
    except KeyError:
        try:
            if gid:
                logger.warning(f"\"{string_name}\" was not translated for \"{customize.get_language(gid)}\".")
                return locales[config["default_language"]][string_name]
            else:
                raise KeyError
        except KeyError:
            raise NotImplementedError(f"\"{string_name}\" was not implemented.")
