""" Web related utilities. """

from aya import nitori, system_administrators, operators


def get_guild_array(guild_list, user):
    result = []
    for guild_obj in guild_list:
        if (guild_obj.permissions_value & 0x8) or user.id in operators or user.id in system_administrators:
            if not any(guild_iterate.id == guild_obj.id for guild_iterate in nitori.guilds):
                continue
            guild_dict = dict(id=guild_obj.id,
                              name=guild_obj.name,
                              icon=guild_obj.icon_url,
                              permissions=guild_obj.permissions_value)
            result.append(guild_dict)
    return result


def get_guild_object(gid, guilds, user):
    for guild_iter in guilds:
        if guild_iter["id"] == gid:
            if not (guild_iter["permissions"] & 0x8) and not (
                    user.id in operators or user.id in system_administrators):
                return False
            return guild_iter
