""" YouTube fetching utilities. """

from youtube_dl import YoutubeDL


youtube_dl_format_options = {
    'format': 'bestaudio/best',
    'outtmpl': './cache/audio/%(extractor)s-%(title)s.%(ext)s',
    'restrictfilenames': True,
    'nocheckcertificate': True,
    'ignoreerrors': True,
    'logtostderr': False,
    'quiet': True,
    'no_warnings': True,
    'default_search': 'auto',
    'extract_flat': True,
    'yesplaylist': True,
    'source_address': '0.0.0.0'
}

youtube_dl_no_playlist = {
    'format': 'bestaudio/best',
    'outtmpl': './cache/audio/%(extractor)s-%(title)s.%(ext)s',
    'restrictfilenames': True,
    'nocheckcertificate': True,
    'ignoreerrors': True,
    'logtostderr': True,
    'quiet': True,
    'no_warnings': True,
    'default_search': 'auto',
    'noplaylist': True,
    'source_address': '0.0.0.0'
}

youtube_dl_aria = {
    'format': 'bestaudio/best',
    'outtmpl': './cache/audio/%(extractor)s-%(title)s.%(ext)s',
    'restrictfilenames': True,
    'nocheckcertificate': True,
    'logtostderr': True,
    'quiet': True,
    'default_search': 'auto',
    'noplaylist': True,
    'external_downloader': 'aria2c',
    'external_downloader_args': ['-q', '--min-split-size', '1M', '--max-connection-per-server', '16', '--split', '16',
                                 '--max-concurrent-downloads', '16'],
    'source_address': '0.0.0.0'
}

youtube_dl = YoutubeDL(youtube_dl_format_options)
youtube_dl_aria = YoutubeDL(youtube_dl_aria)
youtube_dl_no_playlist = YoutubeDL(youtube_dl_no_playlist)


def extract_info(url, playlist=False):
    if playlist:
        return youtube_dl.extract_info(url, download=False)
    else:
        return youtube_dl_no_playlist.extract_info(url, download=False)
